document.addEventListener(
  "DOMContentLoaded",
  function() {
    // TODO: draw all maps and charts
    // set all maps and charts hidden except default
    var startMap = document.getElementById("Bale");
    var startChart = document.getElementById("hinzu");
    startMap.checked = true;
    startChart.checked = true;
    check();
  },
  false
);

d3.select(window).on("resize", throttle);
var tooltipHorizontal =
  document.getElementById("visual-wrapper").clientWidth / 2 + 300;
var tooltipVertical = [1212];
var tooltip = d3
  .select("#world")
  .append("i")
  .attr("id", "tooltip")
  .attr("data-toggle", "tooltip")
  .attr("data-placement", "right")
  .attr("data-trigger", "manual")
  .attr("data-animation", "false")
  .style("background-color", "#00a521")
  .attr(
    "class",
    "text-light font-weight-normal tooltip-inner position-absolute rounded-right"
  );

$("#world").on("mousemove", function(e) {
  $("#tooltip").css({
    top: e.pageY - 580,
    left: e.pageX - 310,
    visibility: "visible"
  });
  $('[data-toggle="tooltip"]').tooltip("show");
});
$("#world").on("mouseleave", function(e) {
  $("#tooltip").css({ visibility: "hidden" });
  $('[data-toggle="tooltip"]').tooltip("hide");
});

function coloring() {
  var checkbox1 = document.getElementById("World");
  var checkbox2 = document.getElementById("Swiss");
  var checkbox3 = document.getElementById("Bale");
  var checkbox4 = document.getElementById("hinzu");
  var checkbox5 = document.getElementById("weg");

  if (checkbox1.checked == true && checkbox4.checked == true) {
    d3.selectAll(".country").attr("fill", function(d, i) {
      return colors(
        umzuge
          .filter(f => f.destination === d.properties.name && f.jahr_id == year)
          .map(a => a.Count)
          .reduce((a, b) => {
            return Number(a) + Number(b);
          }, 0)
      );
    });
  }
  if (checkbox1.checked == true && checkbox5.checked == true) {
    d3.selectAll(".country").attr("fill", function(d, i) {
      return colors(
        umzuge
          .filter(f => f.origin === d.properties.name && f.jahr_id == year)
          .map(a => a.Count)
          .reduce((a, b) => {
            return Number(a) + Number(b);
          }, 0)
      );
    });
  }

  if (checkbox2.checked == true && checkbox4.checked == true) {
    d3.selectAll("path.canton").attr("fill", function(d, i) {
      return colors(
        umzuge
          .filter(f => f.destination === d.properties.abbr && f.jahr_id == year)
          .map(a => a.Count)
          .reduce((a, b) => {
            return Number(a) + Number(b);
          }, 0)
      );
    });
  }
  if (checkbox2.checked == true && checkbox5.checked == true) {
    d3.selectAll("path.canton").attr("fill", function(d, i) {
      return colors(
        umzuge
          .filter(f => f.origin === d.properties.abbr && f.jahr_id == year)
          .map(a => a.Count)
          .reduce((a, b) => {
            return Number(a) + Number(b);
          }, 0)
      );
    });
  }

  if (checkbox3.checked == true && checkbox4.checked == true) {
    d3.selectAll(".quartier").attr("fill", function(d, i) {
      return colorBS(
        veranderung
          .filter(
            f =>
              f.destination_wohnviertel_name === d.properties.TYPE &&
              f.jahr == year
          )
          .map(a => a.Count)
          .reduce((a, b) => {
            return Number(a) + Number(b);
          }, 0)
      );
    });
  }
  if (checkbox3.checked == true && checkbox5.checked == true) {
    d3.selectAll(".quartier").attr("fill", function(d, i) {
      return colorBS(
        veranderung
          .filter(
            f =>
              f.origin_wohnviertel_name === d.properties.TYPE && f.jahr == year
          )
          .map(a => a.Count)
          .reduce((a, b) => {
            return Number(a) + Number(b);
          }, 0)
      );
    });
  }
}
var key = [0, 1, 100, 200, 300, 400, 500, 10000];
var keyLabel = [
  "0",
  "1-100",
  "100-200",
  "201-300",
  "301-100",
  "400-500",
  "500+"
];
var colors = d3
  .scaleLinear()
  .domain(key)
  .range([
    "#ffffff",
    "#CCFFEE",
    "#99FFDD",
    "#66FFCC",
    "#33FFBB",
    "#00FFAA",
    "#00CC88",
    "#009966"
  ]);
var keyBS = [0, 1, 200, 400, 600, 800, 1000, 1200, 1400, 1600, 1800, 4000];
var keyBSLabel = [
  "0",
  "1-200",
  "201-400",
  "401-600",
  "601-800",
  "801-1000",
  "1001-1200",
  "1201-1400",
  "1401-1600",
  "1601-1800",
  "1800+"
];
var colorBS = d3
  .scaleLinear()
  .domain(keyBS)
  .range([
    "#ffffff",
    "#B8E0D3",
    "#9CC9BA",
    "#94D1BD",
    "#66CCAA",
    "#33CC99",
    "#19E6A1",
    "#0AC285",
    "#089163",
    "#056142",
    "#194D3C",
    "#244238"
  ]);

var width = document.getElementById("world").clientWidth - 24;
var height = width / 2;
var widthSlider = document.getElementById("slider-step").clientWidth;

function redraw() {
  width = document.getElementById("world").clientWidth - 24;
  height = width / 2;
  d3.select("#world")
    .select("svg")
    .remove();
  d3.select("#legend")
    .select("svg")
    .remove();
  check();
}

var throttleTimer;
function throttle() {
  window.clearTimeout(throttleTimer);
  throttleTimer = window.setTimeout(function() {
    redraw();
  }, 200);
}
var zoom = d3
  .zoom()
  .scaleExtent([1, 5])
  .on("zoom", function() {
    svg.attr("transform", d3.event.transform);
  });

//Darstellung
function clear() {
  d3.select("#Schweizerkarte").remove();
  d3.select("#Stadtkarte").remove();
  d3.select("#Weltkarte").remove();
}
function Welt() {
  clear();
  drawWorld();
}
function Schweiz() {
  clear();
  drawCH();
}
function Stadt() {
  clear();
  drawBasel();
}

function check() {
  var checkbox1 = document.getElementById("World");
  if (checkbox1.checked == true) {
    world();
  }
  var checkbox2 = document.getElementById("Swiss");
  if (checkbox2.checked == true) {
    cH();
  }
  var checkbox3 = document.getElementById("Bale");
  if (checkbox3.checked == true) {
    bale();
  }
}

function clears() {
  document.getElementById("charts").innerHTML = "";
}
//TODO: split into create map / set visible
function Zuwanderung() {
  coloring();
  clears();
  var checkbox1 = document.getElementById("World");
  var checkbox2 = document.getElementById("Swiss");
  var checkbox3 = document.getElementById("Bale");
  if (checkbox1.checked == true) {
    chartWorldZuwanderung();
  }
  if (checkbox2.checked == true) {
    chartCHZuwanderung();
  }
  if (checkbox3.checked == true) {
    chartBS();
  }
}
function Abwanderung() {
  coloring();
  clears();
  var checkbox1 = document.getElementById("World");
  var checkbox2 = document.getElementById("Swiss");
  var checkbox3 = document.getElementById("Bale");
  if (checkbox1.checked == true) {
    chartWorldAbwanderung();
  }
  if (checkbox2.checked == true) {
    chartCHAbwanderung();
  }
  if (checkbox3.checked == true) {
    chartBS();
  }
}
function drawLegendBS() {
  var size = document.getElementById("legend").innerHeight;
  var div = d3
    .select("#legend")
    .append("svg")
    .attr("height", "100%");
  var legend = div
    .attr("class", "legendgroup")
    .selectAll("g.legend")
    .data(keyBS)
    .enter()
    .append("g")
    .attr("id", "scale-wrapper")
    .append("rect")
    .attr("width", (height / keyBS.length) * 1.5)
    .attr("height", height / keyBS.length)
    .attr("x", 0)
    .attr("y", function(d, i) {
      return 5 + i * (height / keyBS.length);
    })
    .attr("class", "legend")
    .style("fill", function(keyBS, i) {
      return colorBS(keyBS);
    })
    .style("opacity", 0.8);
  d3.selectAll("#scale-wrapper")
    .append("text")
    .attr("fill", "black")
    .attr("x", (height / keyBS.length) * 1.75)
    .attr("y", function(d, i) {
      return (i + 1) * (height / keyBS.length) - 5;
    })
    .text(function(d, i) {
      if (i < 1) {
        return " " + keyBS[i];
      }
      if (i === keyBS.length - 1) {
        return " " + keyBS[i] + "+";
      } else {
        return " " + keyBS[i] + "-" + keyBS[i + 1];
      }
    });
}
function drawLegend() {
  var size = 50;
  var div = d3
    .select("#legend")
    .append("svg")
    .attr("height", "100%");
  var legend = div
    .attr("class", "legendgroup")
    .selectAll("g.legend")
    .data(key)
    .enter()
    .append("g")
    .attr("id", "scale-wrapper")
    .append("rect")
    .attr("width", (height / key.length) * 1.5)
    .attr("height", height / key.length)
    .attr("x", 0)
    .attr("y", function(d, i) {
      return 5 + i * (height / key.length);
    })
    .attr("class", "legend")
    .attr("id", "legend-scale")
    .style("max-width", 50)
    .style("fill", function(d, i) {
      return colors(d);
    })
    .style("opacity", 0.8);
  d3.selectAll("#scale-wrapper")
    .append("text")
    .attr("fill", "black")
    .attr("x", (height / key.length) * 1.75)
    .attr("y", function(d, i) {
      return (i + 1) * (height / key.length) - 10;
    })
    .text(function(d, i) {
      if (i < 1) {
        return +key[i];
      }
      if (i === key.length - 1) {
        return +(key[i - 1] + 100) + "+";
      }
      if (i === key.length - 2) {
        return +key[i] + "-" + (key[i] + 100);
      } else {
        return key[i] + "-" + key[i + 1];
      }
    });
}
function world() {
  d3.select("#legend")
    .select("svg")
    .remove();
  drawLegend();
  Welt();
  clears();
  var checkbox4 = document.getElementById("hinzu");
  var checkbox5 = document.getElementById("weg");
  if (checkbox4.checked == true) {
    chartWorldZuwanderung();
  }
  if (checkbox5.checked == true) {
    chartWorldAbwanderung();
  }
}
function cH() {
  d3.select("#legend")
    .select("svg")
    .remove();
  drawLegend();
  Schweiz();
  clears();
  var checkbox4 = document.getElementById("hinzu");
  var checkbox5 = document.getElementById("weg");
  if (checkbox4.checked == true) {
    chartCHZuwanderung();
  }

  if (checkbox5.checked == true) {
    chartCHAbwanderung();
  }
}
function bale() {
  d3.select("#legend")
    .select("svg")
    .remove();
  drawLegendBS();
  Stadt();
  clears();
  chartBS();
}
//Modusbestimmung
function checkMode(e) {
  e && e.target.id === "world-label"
    ? world() //TODO set world visible
    : e && e.target.id === "swiss-label"
    ? cH() //TODO set ch visible
    : e && e.target.id === "bale-label"
    ? bale() //TODO set basel visible
    : () => {};
}
function checkChart(e) {
  e && e.target.id === "zuwanderung-label"
    ? Zuwanderung()
    : e && e.target.id === "abwanderung-label"
    ? Abwanderung()
    : () => {};
}
// Slider der Jahre
var data = [
  2006,
  2007,
  2008,
  2009,
  2010,
  2011,
  2012,
  2013,
  2014,
  2015,
  2016,
  2017
];
var minYear = d3.min(data);
var maxYear = d3.max(data);
var year;
var sliderStep = d3
  .sliderBottom()
  .min(d3.min(data))
  .max(d3.max(data))
  .width(widthSlider - 100)
  .tickFormat(d3.format(""))
  .ticks(data.length)
  .step(1)
  .default(maxYear)

  .handle(
    d3
      .symbol()
      .type(d3.symbolDiamond)
      .size(200)()
  )
  .on("end", function(event) {
    updateYear();
    coloring();
    clears();
    var checkbox1 = document.getElementById("World");
    var checkbox2 = document.getElementById("Swiss");
    var checkbox3 = document.getElementById("Bale");
    var checkbox4 = document.getElementById("hinzu");
    var checkbox5 = document.getElementById("weg");
    if (checkbox1.checked == true && checkbox4.checked == true) {
      chartWorldZuwanderung();
    }
    if (checkbox2.checked == true && checkbox4.checked == true) {
      chartCHZuwanderung();
    }
    if (checkbox1.checked == true && checkbox5.checked == true) {
      chartWorldAbwanderung();
    }
    if (checkbox2.checked == true && checkbox5.checked == true) {
      chartCHAbwanderung();
    }
    if (checkbox3.checked == true) {
      chartBS();
    }
  });

function updateYear() {
  year = sliderStep.value();
  console.log(year);
}
updateYear();
var gStep = d3
  .select("div#slider-step")
  .append("svg")
  .attr("id", "Jahr")
  .attr("width", widthSlider)
  .attr("height", "100")
  .append("g")
  .attr("transform", "translate(30,30)");

gStep.call(sliderStep);

//Chart Display

const widths = document.getElementById("chart").clientWidth - 50,
  heights = widths,
  maxRadius = Math.min(widths, heights) / 2 - 5;

const formatNumber = d3.format(",d");

const x = d3
  .scaleLinear()
  .range([0, 2 * Math.PI])
  .clamp(true);

const y = d3.scaleSqrt().range([maxRadius * 0.1, maxRadius]);

const color = d3.interpolateRainbow;
const partition = d3.partition();

const arc = d3
  .arc()
  .startAngle(d => x(d.x0))
  .endAngle(d => x(d.x1))
  .innerRadius(d => Math.max(0, y(d.y0)))
  .outerRadius(d => Math.max(0, y(d.y1)));

const middleArcLine = d => {
  const halfPi = Math.PI / 2;
  const angles = [x(d.x0) - halfPi, x(d.x1) - halfPi];
  const r = Math.max(0, (y(d.y0) + y(d.y1)) / 2);

  const middleAngle = (angles[1] + angles[0]) / 2;
  const invertDirection = middleAngle > 0 && middleAngle < Math.PI; // On lower quadrants write text ccw
  if (invertDirection) {
    angles.reverse();
  }

  const paths = d3.path();
  paths.arc(0, 0, r, angles[0], angles[1], invertDirection);
  return paths.toString();
};

const textFits = d => {
  const CHAR_SPACE = 10;

  const deltaAngle = x(d.x1) - x(d.x0);
  const r = Math.max(0, (y(d.y0) + y(d.y1)) / 2);
  const perimeter = r * deltaAngle;

  return d.data.name.length * CHAR_SPACE < perimeter;
};

const svgs = d3
  .select("#chart")
  .append("svg")
  .attr("id", "charts")
  .attr("viewBox", `${-widths / 2} ${-heights / 2} ${widths} ${heights}`)
  .on("click", () => focusOn()); // Reset zoom on canvas click

document
  .getElementById("swiss-label")
  .addEventListener("click", e => checkMode(e));
document
  .getElementById("bale-label")
  .addEventListener("click", e => checkMode(e));
document
  .getElementById("world-label")
  .addEventListener("click", e => checkMode(e));
document
  .getElementById("zuwanderung-label")
  .addEventListener("click", e => checkChart(e));
document
  .getElementById("abwanderung-label")
  .addEventListener("click", e => checkChart(e));

$("#world-label").click(function() {
  $("#world-label").addClass("active");
  $("#bale-label").removeClass("active");
  $("#swiss-label").removeClass("active");
});
$("#swiss-label").click(function() {
  $("#swiss-label").addClass("active");
  $("#world-label").removeClass("active");
  $("#bale-label").removeClass("active");
});
$("#bale-label").click(function() {
  $("#bale-label").addClass("active");
  $("#swiss-label").removeClass("active");
  $("#world-label").removeClass("active");
});
$("#abwanderung-label").click(function() {
  $("#abwanderung-label").addClass("active");
  $("#zuwanderung-label").removeClass("active");
});
$("#zuwanderung-label").click(function() {
  $("#zuwanderung-label").addClass("active");
  $("#abwanderung-label").removeClass("active");
});
