var topo, countries, projection, path, svg, g;

// Load world data
async function drawWorld() {
  await d3.csv("data/migration/OpenDataMigration.csv").then(function(data) {
    umzuge = data.map(function(d) {
      return {
        origin: d.origin,
        jahr_id: d.jahr_id,
        destination: d.destination,
        Count: d.Count
      };
    });
  });

  //country,Longitude,Latitude

  await d3.json("data/geo/world-topo.json").then(function(world) {
    console.log("Step 1 - loading JSON data", world);
    topo = topojson.feature(world, world.objects.countries);

    projection = d3.geoMercator();

    svg = d3
      .select("#world")
      .append("svg")
      .attr("id", "Weltkarte")
      .attr("width", width)
      .attr("height", height)
      .attr("viewBox", "85, -40, 820, 470");
    // .call(zoom);

    path = d3.geoPath().projection(projection);

    countries = d3
      .select("#Weltkarte")
      .selectAll(".country")
      .data(topo.features)
      .enter()
      .append("path")
      .attr("class", "country")
      .attr("d", path)
      .attr("fill", function(d, i) {
        return colors(
          umzuge
            .filter(f => f.origin === d.properties.name && f.jahr_id == year)
            .map(a => a.Count)
            .reduce((a, b) => {
              return Number(a) + Number(b);
            }, 0)
        );
      })
      .style("stroke", "grey")
      .attr("stroke-width", 1)
      .attr("title", function(d, i) {
        return d.properties.name;
      });

    countries
      .on("mousemove", function(d, i) {
        var mouse = d3.mouse(svg.node()).map(function(d) {
          return parseInt(d);
        });
        tooltip
          .classed("hidden", false)

          .html(function() {
            var checkbox4 = document.getElementById("hinzu");
            var checkbox5 = document.getElementById("weg");
            var checkbox6 = document.getElementById("alles");
            if (checkbox4.checked == true && d.properties.name !== "Schweiz") {
              return (
                d.properties.name +
                "<br/>" +
                umzuge
                  .filter(
                    f => f.origin === d.properties.name && f.jahr_id == year
                  )
                  .map(a => a.Count)
                  .reduce((a, b) => {
                    return Number(a) + Number(b);
                  }, 0) +
                " nach Basel-Stadt"
              );
            }
            if (checkbox4.checked == true && d.properties.name == "Schweiz") {
              return (
                "Gesamt" +
                "<br/>" +
                umzuge
                  .filter(
                    f =>
                      f.destination === d.properties.name && f.jahr_id == year
                  )
                  .map(a => a.Count)
                  .reduce((a, b) => {
                    return Number(a) + Number(b);
                  }, 0) +
                " nach Basel-Stadt"
              );
            }
            if (checkbox5.checked == true && d.properties.name !== "Schweiz") {
              return (
                d.properties.name +
                "<br/>" +
                umzuge
                  .filter(
                    f =>
                      f.destination === d.properties.name && f.jahr_id == year
                  )
                  .map(a => a.Count)
                  .reduce((a, b) => {
                    return Number(a) + Number(b);
                  }, 0) +
                " von Basel-Stadt"
              );
            }
            if (checkbox5.checked == true && d.properties.name == "Schweiz") {
              return (
                "Gesamt" +
                "<br/>" +
                umzuge
                  .filter(
                    f => f.origin === d.properties.name && f.jahr_id == year
                  )
                  .map(a => a.Count)
                  .reduce((a, b) => {
                    return Number(a) + Number(b);
                  }, 0) +
                " von Basel-Stadt weg"
              );
            }
          });
      })
      .on("mouseout", function(d, i) {
        tooltip.classed("hide", true);
      });
  });
  // var centers;
  // d3.csv("./GeoData/country_centroids.csv").then(function(data) {
  //   centers = data.map(function(d) {
  //     return {
  //       country: d.country,
  //       Longitude: d.Longitude,
  //       Latitude: d.Latitude
  //     };
  //   });
  // });
}

// var throttleTimer;
// function throttle() {
//   window.clearTimeout(throttleTimer);
//   throttleTimer = window.setTimeout(function() {
//     redraw();
//   }, 200);
// }
